
#include "myrenderer.h"
#include <gtkmm/button.h>
#include <gtk/gtkbutton.h>

using namespace std;

namespace Gtk
{

Glib::PropertyProxy_Base CellRendererButton::_property_renderable()
{
    return property_button();
}

} //namespace Gtk


namespace
{

void CellRendererButton_signal_clicked_callback(GtkCellRendererButton*, const gchar* p0,void* data)
{
    using namespace Gtk;
    typedef SigC::Slot1<void,const Glib::ustring&> SlotType;

    try
    {
        SigC::SlotNode *const slot = Glib::SignalProxyNormal::data_to_slot(data);
        (*(SlotType::Proxy)(slot->proxy_)) (Glib::convert_const_gchar_ptr_to_ustring(p0), slot);
    }
    catch(...)
    {
        Glib::exception_handlers_invoke();
    }
}

const Glib::SignalProxyInfo CellRendererButton_signal_clicked_info =
{
    "clicked",
    (GCallback) &CellRendererButton_signal_clicked_callback,
    (GCallback) &CellRendererButton_signal_clicked_callback
};

} // anonymous namespace


namespace Glib
{

Gtk::CellRendererButton* wrap(GtkCellRendererButton* object, bool take_copy /* = false */)
{
    return dynamic_cast<Gtk::CellRendererButton *> (Glib::wrap_auto ((GObject*)(object), take_copy));
}

} /* namespace Glib */

namespace Gtk
{

/* The *_Class implementation: */

GType CellRendererButton_Class::get_type()
{
    if(!gtype_) // create the GType if necessary
    {
        // Make sure that the parent type has been created.
        CppClassParent::CppObjectType::get_type();

        // Create the wrapper type, with the same class/instance size as the base type.
        register_derived_type(gtk_cell_renderer_button_get_type(), (GClassInitFunc) &class_init_function);

        // Add derived versions of interfaces, if the C type implements any interfaces:
    }

    return gtype_;
}

void CellRendererButton_Class::class_init_function(BaseClassType* klass)
{
    CppClassParent::class_init_function((CppClassParent::BaseClassType*) klass);
    klass->clicked = &clicked_callback;
}


void CellRendererButton_Class::clicked_callback(GtkCellRendererButton* self, const gchar* p0)
{
    CppObjectType *const obj = dynamic_cast<CppObjectType*>(
        Glib::ObjectBase::_get_current_wrapper((GObject*)self));

    if(obj)
    {
        try
        {
            obj->on_clicked(Glib::convert_const_gchar_ptr_to_ustring(p0));
        }
        catch(...)
        {
            Glib::exception_handlers_invoke();
        }
    }
    else
    {
        BaseClassType *const base = static_cast<BaseClassType*>(
            g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class.
            );
        g_assert(base != 0);

        if(base->clicked)
            (*base->clicked)(self, p0);
    }
}


Glib::ObjectBase* CellRendererButton_Class::wrap_new(GObject* o)
{
    return manage(new CellRendererButton((GtkCellRendererButton*)(o)));
}


/* The implementation: */

CellRendererButton::CellRendererButton(GtkCellRendererButton* castitem)
: Gtk::CellRenderer((GtkCellRenderer*)(castitem))
{}

CellRendererButton::~CellRendererButton()
{
    destroy_();
}

CellRendererButton::CppClassType CellRendererButton::cellrendererbutton_class_; //Initialize static member.

GType CellRendererButton::get_type()
{
    return cellrendererbutton_class_.get_type();
}

GType CellRendererButton::get_base_type()
{
    return gtk_cell_renderer_button_get_type();
}

CellRendererButton::CellRendererButton()
: Gtk::CellRenderer((GtkCellRenderer*)(g_object_new(get_type(), (char*)0)))
{}

gpointer CellRendererButton::get_button()
{
    return gtk_cell_renderer_button_get_button(gobj());
}

void CellRendererButton::set_button(gpointer widget)
{
    gtk_cell_renderer_button_set_button(gobj(), widget);
}

void CellRendererButton::set_button(GtkButton *widget)
{
    gtk_cell_renderer_button_set_button(gobj(), (gpointer)widget);
}

void CellRendererButton::set_button(Gtk::Button *widget)
{
    gtk_cell_renderer_button_set_button(gobj(), (gpointer)(widget->gobj()));
}

Glib::SignalProxy1<void,const Glib::ustring&> CellRendererButton::signal_clicked()
{
    return Glib::SignalProxy1<void,const Glib::ustring&>(this, &CellRendererButton_signal_clicked_info);
}


Glib::PropertyProxy<bool> CellRendererButton::property_activatable()
{
    return Glib::PropertyProxy<bool>(this, "activatable");
}

Glib::PropertyProxy<gpointer> CellRendererButton::property_button()
{
    return Glib::PropertyProxy<gpointer>(this, "button");
}

void Gtk::CellRendererButton::on_clicked(const Glib::ustring& path)
{
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class.
        );
    g_assert(base != 0);

    if(base->clicked)
        (*base->clicked)(gobj(), path.c_str());
}


} // namespace Gtk

